/*
 * Language abbreviations and code value. This values was in Symbian Reference.
 * http://developer.symbian.org/main/documentation/reference/s3/pdk/GUID-31C133DE-F245-5992-9A41-20A99291E72A.html
 *
var EN = 1; //ELangEnglish
var AM = 10; //ELangAmerican
var CE = 46; //ELangCanadianEnglish
var IE = 47; //ELangInternationalEnglish
var SA = 48; //ELangSouthAfricanEnglish
*/
var SP = 4; //ELangSpanish
var OS = 82; //ELangInternationalSpanish
var LS = 83; //ELangLatinAmericanSpanish

var PO = 13; //ELangPortuguese
var BP = 76; //ELangBrazilianPortuguese

var strTranslate = new Array();
var systemServiceObj = null;
var langNumber;
var stringTest;

function initSysServiceObj(){
	try {
		systemServiceObj = device.getServiceObject("Service.SysInfo", "ISysInfo");
	} catch (ex){
		alert("System Service object cannot be found.");
		return;
	}
	langNumber = getInputLanguage();
}
function initializeLanguage(){
	var localeXML = getXMLLocale();
	parserXMLLocale(localeXML);
}

//General information
function getInputLanguage(){
	//alert("getInputLanguage");
	//Initialize the criteria for the service object and obtain the
	//information
	var criteria = new Object();
	criteria.Entity = "General";
	criteria.Key = "InputLanguage";
	var result = 1;
	try {
		result = systemServiceObj.ISysInfo.GetInfo(criteria);
	} catch (ex) {
		alert(ex);
		return;
	}
	return result.ReturnValue.Status;
}

function getXMLLocale(){
		
	//alert("Language: " + langNumber);
	var filePath
	var xmlhttp;
		
	//Define the language.
	if (langNumber == PO || langNumber == BP) {
		// load the Portuguese xml
		filePath = "pt/mlp_pt.xml";
	} else if (langNumber == SP || langNumber == OS || langNumber == LS) {
		// load the Spanish xml
		filePath = "es/mlp_es.xml";
	} else {
		// load the Default (English) xml 
		filePath = "en/mlp_en.xml";
	}
	
	//Load XML file.
	if (window.XMLHttpRequest){
		// code for IE7+, Firefox, Chrome, Opera, Safari
		xmlhttp = new XMLHttpRequest();
	} else {
		// code for IE6, IE5
		xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
	}
	
	xmlhttp.open("GET",filePath,false);
	xmlhttp.send();
	return xmlhttp.responseXML;
}

function parserXMLLocale( xmlObject ){

	var strKey;
	var strValue;
	stringTest = "";
	
	var transItems = xmlObject.getElementsByTagName("trans-unit");
	
	for(var i=0; i < transItems.length; i++){
		var tagTrans = transItems[i];
		strKey = tagTrans.getAttribute("resname");
		var srcElements = tagTrans.getElementsByTagName("source")[0];
		strValue = srcElements.textContent;
		
		//strTranslate[strKey] = strValue;
		stringTest += strKey + "=" + strValue + ";";
	}
	flashObject.setStrLanguage(stringTest);
}

function getStringLocale(){
	return stringTest;
}

function getTextByKey(strKey){
	return strTranslate[strKey];
}