/*Translate of Positions of weather
		
	0 = Code
	1 = Temperature
	2 = Date
	3 = City
	4 = Description
	5 = Wind Direction
	6 = Sunrise
	7 = Sunset
*/
var CODE = 0;
var TEMP = 1;
var DATE = 2;
var CITY = 3;
var DESC = 4;
var WIND = 5;
var SRIS = 6;
var SSET = 7;

var NONE_CODE = "none";
var SNOW_CODE = "snow";
var RAIN_CODE = "rain";
var NORMAL_CODE = "normal";
var CLOUDY_CODE = "cloud";

// Determine day or night image
function _getDayNight(weatherArray){
	
	var wpd = weatherArray[DATE];
	
	if(wpd.substr(0,3) != "Off"){
	n = wpd.indexOf(":");
	tpb = _getTimeAsDate(wpd.substr(n-2,8));
	tsr = _getTimeAsDate(weatherArray[SRIS]);
	tss = _getTimeAsDate(weatherArray[SSET]);
	
	if (tpb>tsr && tpb<tss) { 
		return "_d"; 
	} 
	return "_n";
	
	} else {
		var d = new Date();
		var h = (d.getUTCHours() - 4);
		if(h <= 18){
			return "_d"
		}
		return "_n"
	}
}
	// Get time string as date
var _getTimeAsDate = function(t) {
		
	d = new Date();
	r = new Date(d.toDateString() +' '+ t);
		return r;
};

function updateLocalView(weather){
	if(weather[CODE] != "-"){
		updateView("locWeather", weather)		
	} else {
		updateOffLineView("locWeather", weather)
	}
};

function updateAmazonView(weather){
	updateView("amWeather", weather)
};

function updateView( idDiv, weather){
	// var row = 'odd';
	var temp = weather.split(';');
	
	// Format feed items
	var wd = _getWindDirection(temp[WIND]);
	var codeWeather = _getAppWeatherCode(temp[CODE]);
	var daynight = _getDayNight(temp);

	// Add item container
	var html = '<div class="weatherItem"'; 
	html += ' style="background-image: url(\'resources/weather/'+ codeWeather + daynight +'.png\'); background-repeat: no-repeat;"></div>';
	
	html += '<div class="weatherInfo">';
	
	// Add item data
	html += '<div class="weatherCity">'+ temp[CITY] +'</div>';
	
	html += '<div class="weatherTemp">'+ temp[TEMP] +'&deg;</div>';
	
	var wpd = temp[DATE];
	
	if(wpd.substr(0,3) != "Off"){
		html += '<div class="weatherDesc">'+ temp[DESC] +'</div>';
	} else {
		html += '<div class="weatherDesc">Off Line</div>';
	}
		
	html +=' </div>';
	
	updatePlantStatus();
	$('#'+idDiv).html(html);
}

function _getDateFormmated(str){
	var index = str.indexOf("BST");
	index -= 1;
	return str.substring(0, index);
}

function updateOffLineView( idDiv, weather){
	
	if(weather != null){
		
		// Format feed items
		// Add item container
		var html = '<div class="weatherItem">';
		html += '<div class="weatherCity"> </div>';
		
		var temp = weather.split(';');
		html += '<div class="weatherTemp">'+ temp[TEMP] +'</div>';					
		html += '<div class="weatherDesc">'+ temp[DESC] +'</div>';
		html +=' </div>';
		
		$('#'+idDiv).html(html);
	} 
}
	
function loadWeather(){
	
	var html = '<div class="weatherItem">';
	html += '<div class="weatherCity"> </div>';
	html += '<div class="weatherTemp">Loading...</div>';					
	html += '<div class="weatherDesc">.</div>';
	html +=' </div>';

	$('#amWeather').html(html);
	
	if(getUserLocation() != "0"){
		html = '<div class="weatherItem">';
		html += '<div class="weatherCity"> </div>';
		html += '<div class="weatherTemp">Loading...</div>';					
		html += '<div class="weatherDesc">.</div>';
		html +=' </div>';
		
		$('#locWeather').html(html);
	}
}
	
function updatePlantStatus(){
	
	var status = getPlantStatus();
	
	var imgStatus;
	
	if(status == 0){
		imgStatus = '<div style="background-image: url(\'resources/plant/plant.png\'); width: 105px; height: 87px; background-repeat: no-repeat;"></div>';
	} else if(status <= 100){
		imgStatus = '<div style="background-image: url(\'resources/plant/plant_red.png\'); width: 105px; height: 87px; background-repeat: no-repeat;"></div>';
	} else if(status <= 150){
		imgStatus = '<div style="background-image: url(\'resources/plant/plant_orange.png\'); width: 105px; height: 87px; background-repeat: no-repeat;"></div>';
	} else if(status <= 200){
		imgStatus = '<div style="background-image: url(\'resources/plant/plant_green.png\'); width: 105px; height: 87px; background-repeat: no-repeat;"></div>';
	}
	
	$('#plant').html(imgStatus);
}

function _getWindDirection(wd){
	if (wd>=348.75 && wd<=360){
		return "N";
	}
	if(wd>=0 && wd<11.25){
		return "N";
	}
	if(wd>=11.25 && wd<33.75){
		return "NNE";
	}
	if(wd>=33.75 && wd<56.25){
		return "NE";
	}
	if(wd>=56.25 && wd<78.75){
		return "ENE";
	}
	if(wd>=78.75 && wd<101.25){
		return "E";
	}
	if(wd>=101.25 && wd<123.75){
		return "ESE";
	}
	if(wd>=123.75 && wd<146.25){
		return "SE";
	}
	if(wd>=146.25 && wd<168.75){
		return "SSE";
	}
	if(wd>=168.75 && wd<191.25){
		return "S";
	}
	if(wd>=191.25 && wd<213.75){
		return "SSW";
	}
	if(wd>=213.75 && wd<236.25){
		return "SW";
	}
	if(wd>=236.25 && wd<258.75){
		return "WSW";
	}
	if(wd>=258.75 && wd<281.25){
		return "W";
	}
	if(wd>=281.25 && wd<303.75){
		return "WNW";
	}
	if(wd>=303.75 && wd<326.25){
		return "NW";
	}
	if(wd>=326.25 && wd<348.75){
		return "NNW";
	}
	return "";
}

// Get time string as date
var _getTimeAsDate = function(t) {
	
	d = new Date();
	r = new Date(d.toDateString() +' '+ t);
	return r;
};
/*
 * Function responsible to parser the Weather->Current->ServiceCode to
 * AppCode.
 */
function _getAppWeatherCode(serviceCode) {
	var SNOW = [5, 6, 7, 13, 14, 15, 16, 18, 35, 41, 42, 43, 46];	
	var RAIN = [0, 1, 2, 3, 4, 8, 9, 10, 11, 12, 17, 37, 38, 39,40,45,47];
	var NORMAL = [19, 31, 32, 33, 34, 36];
	var CLOUDY = [20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 44];
	
	var code = NONE_CODE;
	if (contains(SNOW, serviceCode)){
		code = RAIN_CODE;
	} else if (contains(RAIN, serviceCode)){
		code = RAIN_CODE;
	} else if (contains(NORMAL, serviceCode)){
		code = NORMAL_CODE;
	} else if (contains(CLOUDY, serviceCode)){
		code = CLOUDY_CODE;
	}
	return code;
}

function getOffLineCodeDescription(code){
	var SNOW_DESCRIPTION = "Snow";
	var RAIN_DESCRIPTION = "Rain";
	var NORMAL_DESCRIPTION = "Normal";
	var CLOUDY_DESCRIPTION = "Cloudy";
	
	if (code == SNOW_CODE){
		//description = SNOW_DESCRIPTION;
		return RAIN_DESCRIPTION;
	} else if (code == RAIN_CODE){
		return RAIN_DESCRIPTION;
	} else if (code == NORMAL_CODE){
		return NORMAL_DESCRIPTION;
	} else if (code == CLOUDY_CODE){
		return CLOUDY_DESCRIPTION;
	}
	return "";
}

function contains(array, element){
	for (var i = 0; i<array.length; i++){
		if (array[i] == element){
			return true;
		}
	}
	return false;
}