
function getWeatherFeed(locationid, unit, callBack) {

	// Create Yahoo Weather feed API address
	var weather;
	
	var api = "http://weather.yahooapis.com/forecastrss?w=" + locationid + "&u=" + unit;

	//Set time out.
	if(locationid == AMAZON_CODE){
		weather = getOffLineAmazonWeather();
	} else {
		weather = getOffLineWeather();
	}

	if(getUpdatePermission() != 0){
	
		try {
			netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
			netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		} catch (e) {
		}
		
		// Send request
		$.ajax( {
			type : 'GET',
			url : api,
			timeout: 30000,
			cache: false,
			dataType : 'xml',
			success: function(data) {
				
				var weatherNS = 'http://xml.weather.yahoo.com/ns/rss/1.0';
				var geo = 'http://www.w3.org/2003/01/geo/wgs84_pos#';
				
				var itens =	data.getElementsByTagName("item")[0];
				
				var location = data.getElementsByTagNameNS(weatherNS, "location")[0];
				var cond = data.getElementsByTagNameNS(weatherNS, "condition")[0];
				var wind = data.getElementsByTagNameNS(weatherNS, "wind")[0]; 
				var astronomy =	data.getElementsByTagNameNS(weatherNS, "astronomy")[0];
				
				var code = cond.getAttribute("code");
				var temp = cond.getAttribute("temp");
				var text = cond.getAttribute("text");

				var city = location.getAttribute("city");
				var estado = location.getAttribute("region");
				var pais = location.getAttribute("country");
				
				var direction =	wind.getAttribute("direction"); 
				
				var sunrise = astronomy.getAttribute("sunrise"); 
				var sunset = astronomy.getAttribute("sunset"); 
				
				var date = itens.getElementsByTagName('pubDate')[0].firstChild.nodeValue;
				
				weather = code + ";" + temp + ";" + date + ";" + city + ";" + text + ";" + direction +";" + sunrise + ";" + sunset; 
			},
			complete : function() {
				callBack(weather);
			}
		});
	} else {
		callBack(weather);
	}
}

function getAttribute( tag, attrName, lengthAttr ){
	var str = "" + tag.toString();
	var pos = str.lastIndexOf(attrName);
	var init = pos + attrName.length + 2;
	
	return str.substring(init, init + lengthAttr);
}

// Generate a fake weather.
function getOffLineAmazonWeather() {

	var newWeatherCode;
	
	// based in the Yahoo Weather API.
	newWeatherCode = randomInterval(0, 47);
	
	// Based in a normal minimum and max temperature to Amazon.
	var offLineTemp =  randomInterval(28, 42);
	var offLineWeather;
	
	offLineWeather = newWeatherCode + ";"
				+ offLineTemp + ";" 
				+ "Off line" + ";" 
				+ "Manaus ;;0;;";

	return offLineWeather;
}

//Returns a off line weather to miniview.
function getOffLineWeather(){
	var offLineWeather = "-; Off_line;;;;;;";
	return offLineWeather;
}

function randomInterval(numInicial, numFinal){
	var numero = Math.floor((Math.random()*(numFinal-numInicial))+numInicial); 
	return numero;
}